/*
* Authors: Group 4 Adam Elghor, Brian Kaplan, Sayak Chatterjee, Moraa Onwonga
* Purpose: Controls the LOCK state of the machine
* Language: C
*/
#include "lock.h"
#include "authentication.h"
#include "actuators.h"
#include "powerManagement.h"
#include "parameters.h"

/*
* Function:  lock
* --------------------
*  Locks safe
*
*  returns: the next state in the state machine
*  Open: After it has been locked
*
*/
enum states lock() {
	if(authenticateLock()) {
		openSafe();
		wait(5);
		return OPEN;
	} else {
		return LOCK;
	}
}

/*
* Function: authenticate
* ----------------------------
*  Checks whether a cup was found through the sonar sensor
*
*  returns: true if cup found else false
*/
bool authenticateLock() {
    return CorrectEntrySequenceAttempt();
}

